#!/bin/sh
#
#
version_path=/var/www/innovaphone/apps/innovaphone-reporting

rm -f /var/www/innovaphone/tmp/hotfix_lighttpd.restart
version=`tr -d '\n\r ' < ${version_path}/version`
for folder in $(ls -1 | grep -o '^[0-9]*$')
do
    if [ ${version} -gt ${folder} ]; then
        echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - Ignoring already installed service release for build ${folder}"
    elif [ ${version} -eq ${folder} ]; then
        echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - Installing service release for build ${folder}"
        cd ${folder}
        gzip -d *.gz
        tar_file=`ls -1 *.tar`
        tar xf ${tar_file}
        rm ${tar_file}
        cp ../php_template.sh .
        dos2unix *.sh
        install_exes=( $(ls install*.*) )
        num_exes=${#install_exes[@]}
        if [ ${num_exes} -eq 1 ]; then
            install_exe=${install_exes[0]}
            chmod 755 ${install_exe}
            echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - Executing installation script ${install_exe}"
            ./${install_exe} 1
            if [ $? -ne 0 ]; then
                echo "ERROR: $(date '+%Y-%m-%d %H:%M:%S') - Service release installation failed"
                exit 1
            fi
        else
            echo "ERROR: $(date '+%Y-%m-%d %H:%M:%S') - No installation script found"
            exit 1
        fi
        cd ..
        version=`tr -d '\n\r ' < ${version_path}/version`
    elif [ ${version} -lt ${folder} ]; then
        echo "ERROR: $(date '+%Y-%m-%d %H:%M:%S') - Currently installed build is ${version}. Can't apply service release for build ${folder}."
        exit 1
    fi
done

if [ -f /var/www/innovaphone/tmp/hotfix_lighttpd.restart ]; then
    echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - The web server will be restarted a few seconds after the installation!"
fi
echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - Installation was successful"
if [ -f /var/www/innovaphone/tmp/hotfix_lighttpd.restart ]; then
    sleep 10s
    php5-cgi /var/www/innovaphone/update_webserver_cfg.php
    rm -f /var/www/innovaphone/tmp/hotfix_lighttpd.restart
fi